#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
 Socktroll bot
 Copyright (C) 2008-2009  Patrik Lembke

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from blamlib.protocols.clients import Socktroll_Client
import knowledge

class Obo( Socktroll_Client ):
    """A knowledge bot"""

    def on_bad_nick( self, type ):
        print " * auth fail: %s" % type
        self.close()

    def on_ok_nick( self ):
        print " * authed =)"

    def on_msg( self, sender, text ):
        print "<%s> %s" %( sender, text )

        knowledge.seen_update( sender, 'chan' )
        
        if text.startswith( self.nick + ":" ):
            # Parse evilcode (for socktroll)
            text = text.replace( self.nick + ":", "" )
            while text[0] == ' ':
                text = text[1:]
                                 
            lines = knowledge.praseQ( text , sender )

            if type( lines ) == str:
                lines = [ lines ]
            
            for line in lines:
                if line == "!SILENT!":
                    pass
                else:
                    self.send_msg( "%s: %s" %( sender, line ) )

    def on_action( self, sender, text ):
        print " * %s %s" %( sender, text )
        knowledge.seen_update( sender, 'chan' )

    def on_join( self, who ):
        print " + %s" % who
        knowledge.seen_update( who, 'join' )
    
    def on_part( self, who ):
        print " - %s" % who
        knowledge.seen_update( who, 'part' )

    def on_rename( self, was, now_is ):
        print " i %s -> %s" %( was, now_is )
        knowledge.seen_update( was, 'rename' )
        knowledge.seen_update( now_is, 'rename' )

if __name__ == '__main__':
    from time import sleep
    # blambi.chebab.com
    client = Obo( "localhost", 6000, 'obo' )
    knowledge.nick = client.nick
    knowledge.troll_client = client
    
    while client.connected:
        client.poll()
        sleep( 0.001 )
